//it is i, sz_ (or appleblurt), i am your... Coder!!!!!!!!!!!!!!!!!!!!
freeslot("SPR_BSID", "SPR_BNEO", "SPR_BFDD","SFX_GFSAD","SFX_GFLAP","SFX_GFCH1","SFX_GFCH2","SFX_BFDED", "SFX_BFCON")
local sk = "bfxml"

local function hitPlayer(player, inflictor, source)
	if (player.mo and player.mo.valid and source.valid and source.player and source.skin == sk)
		source.player.gfappear = 1
		source.player.gfexpression = 0
		if (player.mo.skin == sk)
			if (player.kartstuff[k_bumper] == 1)
				COM_BufInsertText(player, "tunes none")
				player.bfdead = 2
				S_StartSound(nil, sfx_bfded, player)
				player.bfw = 1
			else
				player.gfappear = 1
				player.gfexpression = 1
			end
		end
	end
end

local function cheerPlayer(player)
	local rng = P_RandomRange(0,1)
	if (rng == 0)
		S_StartSound(nil, sfx_gfch1, player)
	else
		S_StartSound(nil, sfx_gfch2, player)
	end
end

addHook("ThinkFrame", do
	for player in players.iterate do
		if (player.mo and player.mo.valid and player.mo.skin == sk)
			player.bfdead = $ or 0
			player.bfw = $ or 0
			player.bfpress = $ or 0
			player.gfappear = $ or 0
			player.gfexpression = $ or 0
			player.gfypos = $ or 0
			player.gfgrav = $ or 0
			player.mo.bfexplode = $ or 0
			if (player.bfdead > 0)
				if not S_IdPlaying(sfx_bfded) and (player.bfw == 1)
					COM_BufInsertText(player, "tunes bfgmv")
					player.bfw = 2
				end
				player.bfdead = $ + 1
			end
			if (player.bfw == 1)
				COM_BufInsertText(player, "tunes none")
			end
			if (player.bfw == 2) or (player.bfw == 3)
				if (player.cmd.forwardmove ~= 0) and (player.bfpress == 0)
					player.bfpress = 1
					if (player.bfw == 2)
						player.bfw = 3
					else
						player.bfw = 2
					end
				end
				if (player.bfpress == 1) and (player.cmd.forwardmove == 0)
					player.bfpress = 0
				end
				if (player.cmd.buttons & BT_ATTACK)
					if (player.bfw) and not S_IdPlaying(sfx_bfcon) 
						player.bfw = 4
						COM_BufInsertText(player, "tunes none")
						S_StartSound(nil, sfx_bfcon, player)
					end
				end
			end
			if not S_IdPlaying(sfx_bfcon) and (player.bfw == 4)
				player.bfdead = 0
				player.bfw = 0
				COM_BufInsertText(player, "tunes -default")
			end
			if (leveltime == 0) or (player.realtime == 0)
				player.bfdead = 0
				player.gfappear = 0
				player.gfexpression = 0
				player.gfypos = 0
				player.gfgrav = 0
				player.mo.bfexplode = 0				
			end
			if (player.mo.bfexplode == 1)
				player.mo.frame = 0
				player.mo.sprite = SPR_BFDD
				if (player.kartstuff[k_spinouttimer] == 0)
					player.mo.bfexplode = 0
				end
			end
			if (player.kartstuff[k_lapanimation] == 75)
				player.gfappear = 1
				player.gfexpression = 2
				if (player.kartstuff[k_laphand] == 3)
					player.gfexpression = 1
					S_StartSound(nil, sfx_gfsad, player)
				else
					if (player.kartstuff[k_laphand] == 1) and (player.exiting)
						player.gfexpression = 0
					end
					S_StartSound(nil, sfx_gflap, player)
				end
			end
			if (player.gfappear == 1)
				player.gfypos = 1
				player.gfgrav = -5
				player.gfappear = $ + 1
			end
			if (player.gfappear == 2)
				if (leveltime % 6 == 0)
					player.gfgrav = $ + 1
				end
				player.gfypos = $ - player.gfgrav
				if (player.gfypos < 0)
					player.gfappear = 0
				end
			end
			if (player.mo.color == SKINCOLOR_PASTEL)
				player.mo.sprite = SPR_BSID
			end
			if (player.mo.color == SKINCOLOR_LAVENDER)
				player.mo.sprite = SPR_BNEO
			end
		end
	end
end)

addHook("PlayerExplode", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == sk)
		player.mo.bfexplode = 1
	end
end)

addHook("ShouldSpin", function(player, inflictor, source)
	hitPlayer(player, inflictor, source)
end)

addHook("ShouldSquish", function(player, inflictor, source)
	hitPlayer(player, inflictor, source)
end)

addHook("ShouldExplode", function(player, inflictor, source)
	hitPlayer(player, inflictor, source)
end)

local function drawGame(v, p)
	if not (p.mo) return end
	if (p.mo.skin ~= sk) return end
	local d = "GFYAY"
	if (p.gfexpression == 1)
		d = "GFSAD"
	elseif (p.gfexpression == 2)
		d = "GFLAP"
	end
	v.draw(260,200 - p.gfypos, v.cachePatch(d), V_SNAPTOBOTTOM)
end

local function gameOver(v, p)
	if not (p.mo) return end
	if (p.mo.skin ~= sk) return end
	if (p.bfdead == 0) return end
	local d = "BFDEAD5"
	local o = "BFCON1"
	local size = FRACUNIT-((1-p.bfdead+20)*FRACUNIT/128)
	if ((FRACUNIT+FRACUNIT/3) <= size)
		size = FRACUNIT+FRACUNIT/3
	end
	if (p.bfdead <= 2)
		d = "BFDEAD5"
	elseif (p.bfdead > 2 and p.bfdead <= 2+2) //2
		d = "BFDEAD4"
	elseif (p.bfdead > 4 and p.bfdead <= 4+3) //3
		d = "BFDEAD3"
	elseif (p.bfdead > 7 and p.bfdead <= 7+4) //4
		d = "BFDEAD2"
	elseif (p.bfdead > 11 and p.bfdead <= 11+5) //5
		d = "BFDEAD1"
	elseif (p.bfdead > 16 and p.bfdead <= 16+6)
		d = "BFDEAD8"
	elseif (p.bfdead > 22 and p.bfdead <= 22+7)
		d = "BFDEAD7"
	elseif (p.bfdead > 29 and p.bfdead <= 29+8)
		d = "BFDEAD6"
	elseif (p.bfdead > 37 and p.bfdead <= 37+9)
		d = "BFDEAD5"
	elseif (p.bfdead > 46 and p.bfdead <= 46+10)
		d = "BFDEAD4"
	elseif (p.bfdead > 56 and p.bfdead <= 56+11)
		d = "BFDEAD3"
	else
		d = "BFDEAD2"
	end
	if (p.bfw == 3)
		o = "BFCON2"
	end
	v.drawScaled(0,0,100*FRACUNIT,v.cachePatch("BLACKBF"), V_SNAPTOLEFT|V_SNAPTOTOP)
	if (p.bfw != 4)
		v.drawScaled(160*FRACUNIT,145*FRACUNIT, size, v.cachePatch(d), V_SNAPTOBOTTOM, v.getColormap(p.mo.skin, p.mo.color))
	end
	if (p.bfw == 2) or (p.bfw == 3)
		v.draw(0,0,v.cachePatch(o),V_SNAPTOTOP|V_SNAPTOLEFT)
	end
end

hud.add(drawGame, "game")
hud.add(gameOver, "game")